'                   Copyright (c) 2005 SQUARE ENIX CO.,LTD.
'                             All Rights Reserved.
'  
'  This file contains unpublished confidential  and proprietary information
'  of SQUARE ENIX CO.,LTD.  The contents of this file  may not be copied or
'  duplicated,  in whole or in part, by any means,  electronic or hardcopy,
'  without  the express  prior written permission  of  SQUARE ENIX CO.,LTD.
'  This copyright notice does not imply any actual or intended publication.
'  
'  $Id: SaveWeightPresets.vbs,v 1.1 2005/03/04 12:16:40 ebisawa Exp $
'  
'  Author: Atsushi Ebisawa (ebisawa@square-enix.co.jp)
'  
Option Explicit

sub aeSavePreset( oObj, strSaveFolder )
    Dim oCls, oProp
    for each oCls in oObj.ActivePrimitive.Geometry.Clusters
'        logmessage "cluster: " & oCls.name & "(" & oCls.type & ")"
        for each oProp in oCls.Properties
            if oProp.type = "envweights" then
                SavePreset oProp.fullname, oObj.name, strSaveFolder, siDefaultLocation, True
            end if
        next
    next
end sub

Function GetSpecificWndHnds(ByVal sClsName, ByVal sCaption, ByRef hRetArr)'Ret WndCnt

    'EChEhWnd
    Dim obj_FindWindowEx
    Set obj_FindWindowEx = CreateObject("DynamicWrapper")
'    Set obj_FindWindowEx = Nothing 

    lHitCnt = 0

    hNext = obj_FindWindowEx.FindWindowEx(0, 0, CStr(sClsName), CStr(sCaption))

    Do while hNext
    ReDim Preserve hRetArr(lHitCnt)
    hRetArr(lHitCnt) = hNext
    lHitCnt = lHitCnt + 1
    hNext = obj_FindWindowEx.FindWindowEx(0, hNext, CStr(sClsName), CStr(sCaption))
    Loop

    GetSpeficWndHnds = lHitCnt

End Function
function SelectFolder()
    Dim Shell, oSaveFolder
    Dim path
    Set Shell=CreateObject("Shell.Application")
'    Shell.AppActivate "Calculator"
'    Dim hRetArr()
'    Dim hWnd
'    Set hWnd = GetSpecificWndHnds( "afx", "SOFTIMAGE(R) | XSI(R) v.4.2 (Adv)", hRetArr )
    path = Application.InstallationPath( siProjectPath )
    Set oSaveFolder = Shell.BrowseForFolder(0,"Select Save Folder: "&path&"\",128+16+1, path)
    if oSaveFolder <> "Nothing" then
        SelectFolder = oSaveFolder.Items.Item.Path
    end if
end function

'---------------
function XSILoadPlugin( in_reg )
	in_reg.Author = "nuenaka"
	in_reg.Name = "SaveWeightPresetsPlugin"
	in_reg.Email = "nuenaka@square-enix.co.jp"
	in_reg.URL = "http://happy/document/XSI/index.html"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterCommand "SaveWeightPresets","SaveWeightPresets"
	'RegistrationInsertionPoint - do not remove this line

	XSILoadPlugin = true
end function

function XSIUnloadPlugin( in_reg )
	XSIUnloadPlugin = true
end function

function SaveWeightPresets_Init( ctxt )
	dim oCmd
	set oCmd = ctxt.Source
	oCmd.Description = ""
	oCmd.ReturnValue = true

	SaveWeightPresets_Init = true
end function

function SaveWeightPresets_Execute(  )


	dim tpc
	tpc = TechPluginCertification( "SaveWeightPresets", "1.2" )
	if tpc <> True then
		' false ɂƗvȂG[bZ[Wô true ƂB
	else

Dim sel
Dim saveFolder

saveFolder = SelectFolder
for each sel in Selection
    aeSavePreset sel, saveFolder
next

	end if 'TPC

	SaveWeightPresets_Execute = true
end function




