'                   Copyright (c) 2004 SQUARE ENIX CO.,LTD.
'                             All Rights Reserved.
'  
'  This file contains unpublished confidential  and proprietary information
'  of SQUARE ENIX CO.,LTD.  The contents of this file  may not be copied or
'  duplicated,  in whole or in part, by any means,  electronic or hardcopy,
'  without  the express  prior written permission  of  SQUARE ENIX CO.,LTD.
'  This copyright notice does not imply any actual or intended publication.
'  
'  $Id: RoundingWeights.vbs,v 1.3 2005/01/26 11:35:13 ebisawa Exp $
'  
'  Author: Atsushi Ebisawa (ebisawa@square-enix.co.jp)
'  
Option Explicit

Function RoundWeight( oObj )
    Dim oEnvelope, oWeights, wstr
    Dim iElement, iDeformer
    Dim totalWeight, rest
    Dim maxDeformer, maxValue, w, iw
    
    ' componentobject֕ϊ (ɂƂ悢ϊ@͂)
    Dim oColl
    set oColl = CreateObject( "XSI.Collection" )
    Dim tmp, objName
    tmp = instr( oObj.fullname, ".pnt" )
    objName = left( oObj.fullname, tmp-1 )

    oColl.add( objName )
    set oEnvelope = oColl(0).ActivePrimitive.ConstructionHistory.find("envelopop")
    oWeights = oEnvelope.Weights.Array

    Dim aElements
    aElements = oObj.SubElements

    Dim i
    For i = 0 to ubound( aElements )
        iElement = aElements(i)
        totalWeight = 0
        rest = 0.0
        maxValue = 0.0
        For iDeformer = lbound( oWeights, 1 ) to ubound( oWeights, 1 )
            w = oWeights(iDeformer, iElement)
            If maxValue < w Then
                maxValue = w
                maxDeformer = iDeformer
            End If
            rest = rest + (w - int(w))
            iw = int(w)
            If rest > 1.0 Then
                rest = rest - 1.0
                iw = iw + 1
            End If
            oWeights(iDeformer, iElement) = iw
            totalWeight = totalWeight + iw 
        Next
        If totalWeight <> 100 Then
'            LogMessage "TotalWeight: def=" & maxDeformer & ",  vert=" & iElement & " (" & maxValue & ")"
            ' Ōɗ]́AԃEFCg傫Ƃ֑B
            oWeights(maxDeformer, iElement) = oWeights(maxDeformer, iElement) + (100 - totalWeight)
        End If
    Next
    oEnvelope.Weights.Array = oWeights
End Function


'---------------
function XSILoadPlugin( in_reg )
	in_reg.Author = "nuenaka"
	in_reg.Name = "RoundingWeightsPlugin"
	in_reg.Email = "nuenaka@square-enix.co.jp"
	in_reg.URL = "http://happy/document/XSI/index.html"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterCommand "RoundingWeights","RoundingWeights"
	'RegistrationInsertionPoint - do not remove this line

	XSILoadPlugin = true
end function

function XSIUnloadPlugin( in_reg )
	XSIUnloadPlugin = true
end function

function RoundingWeights_Init( ctxt )
	dim oCmd
	set oCmd = ctxt.Source
	oCmd.Description = ""
	oCmd.ReturnValue = true

	RoundingWeights_Init = true
end function

function RoundingWeights_Execute(  )


	dim tpc
	tpc = TechPluginCertification( "RoundingWeights", "1.4" )
	if tpc <> True then
		' false ɂƗvȂG[bZ[Wô true ƂB
	else


Dim s
For Each s In selection
    RoundWeight( s )
Next

	end if		' TPC


	RoundingWeights_Execute = true
end function

